SystemOrganization addCategory: #'Collections-Tests-Strings'!

CollectionRootTest subclass: #StringTest
	uses: TIncludesTest + TCloneTest + TCopyTest + TSetArithmetic + TIterateSequencedReadableTest + TPrintOnSequencedTest + TAsStringCommaAndDelimiterSequenceableTest + TIndexAccess + TSequencedElementAccessTest + TSubCollectionAccess + TPutBasicTest + TCopySequenceableSameContents + TCopyPartOfSequenceable + TCopyPartOfSequenceableForMultipliness + TCopySequenceableWithOrWithoutSpecificElements + TCopySequenceableWithReplacement + TReplacementSequencedTest + TConvertTest - {#testAsByteArray} + TConvertAsSortedTest + TBeginsEndsWith + TIndexAccessForMultipliness - {#testIdentityIndexOfIAbsentDuplicate. #testIdentityIndexOfDuplicate. #collectionWithNonIdentitySameAtEndAndBegining} + TSequencedConcatenationTest + TPutTest + TConvertAsSetForMultiplinessTest + TSortTest + TSequencedStructuralEqualityTest + TOccurrencesForMultiplinessTest + TCreationWithTest
	instanceVariableNames: 'string emptyString elementInNonEmpty notIn nonEmpty1element withoutEqualElements collectionNotIncluded indexInNonEmptyArray sameAtEndAndBegining nonEmpty5ElementsSorted unsortedCollection subcollection3ElementsSorted arrayWithCharacters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-Strings'!

!StringTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class String. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- there is a chapter in the PharoByExample book (http://pharobyexample.org/)
	- the sunit class category!

StringTest class
	uses: TIncludesTest classTrait + TCloneTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TIterateSequencedReadableTest classTrait + TAsStringCommaAndDelimiterSequenceableTest classTrait + TIndexAccess classTrait + TSequencedElementAccessTest classTrait + TSubCollectionAccess classTrait + TPutBasicTest classTrait + TCopySequenceableSameContents classTrait + TCopyPartOfSequenceable classTrait + TCopyPartOfSequenceableForMultipliness classTrait + TCopySequenceableWithOrWithoutSpecificElements classTrait + TCopySequenceableWithReplacement classTrait + TReplacementSequencedTest classTrait + TConvertTest classTrait + TConvertAsSortedTest classTrait + TBeginsEndsWith classTrait + TIndexAccessForMultipliness classTrait + TSequencedConcatenationTest classTrait + TPrintOnSequencedTest classTrait + TPutTest classTrait + TConvertAsSetForMultiplinessTest classTrait + TSortTest classTrait + TSequencedStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait + TCreationWithTest classTrait
	instanceVariableNames: ''!

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:57'!
aValue
" return a value to put into nonEmpty"
	^ elementInNonEmpty ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:58'!
anIndex
" return an index in nonEmpty bounds"
	^ 2! !

!StringTest methodsFor: 'tests - includes' stamp: 'stephane.ducasse 11/21/2008 15:09'!
anotherElementNotIn
	^ $k! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:02'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection  anyOne! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:02'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ notIn ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:57'!
anotherValue
" return a value ( not eual to 'aValue' ) to put into nonEmpty "
	^ self nonEmpty anyOne.! !

!StringTest methodsFor: 'tests - includes' stamp: 'stephane.ducasse 11/21/2008 15:09'!
collection
	^ 'ghj'! !

!StringTest methodsFor: 'test - set arithmetic' stamp: 'stephane.ducasse 12/20/2008 21:57'!
collectionClass

	^ String! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:32'!
collectionMoreThan1NoDuplicates
	" return a collection of size > 1 without equal elements"
	^ withoutEqualElements ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/14/2009 14:52'!
collectionMoreThan5Elements
" return a collection including at least 5 elements"
	
	^ nonEmpty5ElementsSorted ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:03'!
collectionNotIncluded
" return a collection for wich each element is not included in 'nonEmpty' "
	^ notIn ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
collectionWith1TimeSubcollection
	" return a collection including 'oldSubCollection'  only one time "
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:43'!
collectionWith2TimeSubcollection
	" return a collection including 'oldSubCollection'  two or many time "
	^ nonEmpty5ElementsSorted , subcollection3ElementsSorted ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
collectionWithElement
	"Returns a collection that already includes what is returned by #element."
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:41'!
collectionWithElementsToRemove
" return a collection of elements included in 'nonEmpty'  "
	^ subcollection3ElementsSorted ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 15:59'!
collectionWithEqualElements
" return a collecition including atLeast two elements equal"

^ sameAtEndAndBegining ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 11:30'!
collectionWithSameAtEndAndBegining
" return a collection with elements at end and begining equals .
(others elements of the collection are not equal to those elements)"
	^ sameAtEndAndBegining ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
collectionWithSortableElements
	" return a collection only including elements that can be sorted (understanding '<' )"
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 13:26'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^ withoutEqualElements ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 11:27'!
collectionWithoutEqualsElements

" return a collection not including equal elements "
	^ withoutEqualElements ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
collectionWithoutNilElements
	" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 13:12'!
element
	"Returns an object that can be added to the collection returned by #collection."
	^ elementInNonEmpty ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:40'!
elementInForElementAccessing
" return an element inculded in 'moreThan4Elements'"
	^ self moreThan4Elements anyOne! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:06'!
elementInForIncludesTest
" return an element included in nonEmpty "
	^ elementInNonEmpty ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:32'!
elementInForIndexAccessing
" return an element included in 'accessCollection' "
	^ withoutEqualElements anyOne! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 14:06'!
elementNotIn
"return an element not included in 'nonEmpty' "

	^notIn ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:41'!
elementNotInForElementAccessing
" return an element not included in 'moreThan4Elements' "
	^ notIn ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:32'!
elementNotInForIndexAccessing
" return an element not included in 'accessCollection' "
	^ notIn ! !

!StringTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
elementNotInForOccurrences
	^ $z! !

!StringTest methodsFor: 'test - copy' stamp: 'delaunay 4/17/2009 15:26'!
elementToAdd
	^ $u! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 15:59'!
elementTwiceInForOccurrences
" return an element included exactly two time in # collectionWithEqualElements"
^ sameAtEndAndBegining first .! !

!StringTest methodsFor: 'requirements' stamp: 'stephane.ducasse 11/21/2008 15:08'!
empty
	^ emptyString! !

!StringTest methodsFor: 'tests - indexof' stamp: 'on 5/13/2008 16:34'!
findFirstInString: aString fromString: searchString

	^ String findFirstInString: aString inSet: (CharacterSet newFrom: searchString) byteArrayMap startingAt: 1! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
firstCollection
	" return a collection that will be the first part of the concatenation"
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 13:24'!
firstIndex
" return an index between 'nonEmpty' bounds that is < to 'second index' "
	^3! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 11:03'!
indexArray
" return a Collection including indexes between bounds of 'nonEmpty' "

	^ indexInNonEmptyArray ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 11:28'!
indexInForCollectionWithoutDuplicates
" return an index between 'collectionWithoutEqualsElements'  bounds"
	^ 2! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 11:31'!
indexInNonEmpty
" return an index between bounds of 'nonEmpty' "

	^ 2.! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
integerCollectionWithoutEqualElements
	" return a collection of integer without equal elements"
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
moreThan3Elements
	" return a collection including atLeast 3 elements"
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
moreThan4Elements
	" return a collection including at leat 4 elements"
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 13:24'!
newElement
"return an element that will be put in the collection in place of another"
	^ elementInNonEmpty ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
nonEmpty
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:26'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^ nonEmpty1element ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:52'!
nonEmptyMoreThan1Element
	" return a collection that don't includes equl elements'"
	^ nonEmpty5ElementsSorted! !

!StringTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:43'!
oldSubCollection
" return a subCollection included in collectionWith1TimeSubcollection .
ex :   subCollection := #( 2 3 4) and collectionWith1TimeSubcollection := #(1 2 3 4 5)"
	^ subcollection3ElementsSorted  ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 13:12'!
otherCollection
	"Returns a collection that does not include what is returned by #element."
	^ collectionNotIncluded ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 11:35'!
replacementCollection
" return a collection that will be used to replace 'oldSubcollection' in ' collectionWith1TimeSubcollection'  " 
	^ string! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 13:23'!
replacementCollectionSameSize
" return a collection of size (secondIndex - firstIndex + 1)"
	^nonEmpty1element ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:33'!
secondCollection
" return a collection that will be the second part of the concatenation"
	^ nonEmpty1element ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 13:25'!
secondIndex
" return an index between 'nonEmpty' bounds that is > to 'second index' "
	^ self firstIndex ! !

!StringTest methodsFor: 'initialization' stamp: 'cyrille.delaunay 12/18/2009 13:47'!
setUp
	string := 'Hi, I am a String'.
	emptyString := ''.
	subcollection3ElementsSorted := 'bcd'.
	nonEmpty5ElementsSorted := 'a' , subcollection3ElementsSorted , 'e'.
	unsortedCollection := 'azsbe'.
	indexInNonEmptyArray := #(1 3 2 ).
	arrayWithCharacters := #($a $b $c ).
	nonEmpty1element := 'a'.
	withoutEqualElements := 'abcde'.
	
	sameAtEndAndBegining := 'abca'.
	elementInNonEmpty := $c.
	collectionNotIncluded := notIn asString , notIn asString.
	notIn := $z! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/24/2009 15:19'!
sizeCollection
	"Answers a collection whose #size is 4"
	^ 'abcd'! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:54'!
sortedInAscendingOrderCollection
" return a collection sorted in an acsending order"
	^nonEmpty5ElementsSorted 
	! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 10:45'!
subCollectionNotIn
" return a collection for which at least one element is not included in 'moreThan4Elements' "
	^ collectionNotIncluded ! !

!StringTest methodsFor: 'tests - fixture' stamp: 'delaunay 4/17/2009 15:26'!
test0CopyTest
	self 
		shouldnt: self empty
		raise: Error.
	self assert: self empty size = 0.
	self 
		shouldnt: self nonEmpty
		raise: Error.
	self assert: (self nonEmpty size = 0) not.
	self 
		shouldnt: self collectionWithElementsToRemove
		raise: Error.
	self assert: (self collectionWithElementsToRemove size = 0) not.
	self 
		shouldnt: self elementToAdd
		raise: Error! !

!StringTest methodsFor: 'testing - converting' stamp: 'MarcusDenker 8/15/2010 11:07'!
testAsCamelCase

       self assert: 'A man, a plan, a canal, panama' asCamelCase = 'AMan,APlan,ACanal,Panama'.
       self assert: 'Here 123should % be 6 the name6 of the method' asCamelCase = 'Here123should%Be6TheName6OfTheMethod'.
 ! !

!StringTest methodsFor: 'tests - converting' stamp: 'sd 6/5/2005 09:26'!
testAsInteger

	self assert: '1796exportFixes-tkMX' asInteger = 1796.
	self assert: 'donald' asInteger isNil.
	self assert: 'abc234def567' asInteger = 234.
	self assert: '-94' asInteger = -94.
	self assert: 'foo-bar-92' asInteger = -92! !

!StringTest methodsFor: 'tests - converting' stamp: 'sd 6/5/2005 09:27'!
testAsSmalltalkComment

	| exampleStrings  |
	exampleStrings := #(
		''
		' '
		'"'
		'""'
		'"""'
		'abc"abc'
		'abc""abc'
		'abc"hello"abc'
		'abc"'
		'"abc' ).

	"check that the result of scanning the comment is empty"
	exampleStrings do: [ :s |
		| tokens  |
		tokens :=  Scanner new scanTokens: s asSmalltalkComment.
		self assert: (tokens isEmpty) ].

	"check that the result has the same non-quote characters as the original"
	exampleStrings do: [ :s |
		self assert: ( (s copyWithout: $") = (s asSmalltalkComment copyWithout: $"))].

	"finnaly, test for some common kinds of inputs"
	self assert: ( 'abc' asSmalltalkComment = '"abc"').
	self assert: ( 'abc"abc' asSmalltalkComment = '"abc""abc"').
	self assert: ('abc""abc' asSmalltalkComment = '"abc""abc"' ).
		! !

!StringTest methodsFor: 'tests - as sorted collection' stamp: 'hfm 4/2/2010 13:41'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: Array).
	self assert: result isSorted.
	self assert: result size = collection size! !

!StringTest methodsFor: 'tests - accessing' stamp: 'sd 6/5/2005 09:27'!
testAt

	self assert: (string at: 1) = $H.! !

!StringTest methodsFor: 'tests - converting' stamp: 'sd 6/5/2005 09:27'!
testCapitalized

	| uc lc empty |		
	uc := 'MElViN'.
	lc := 'mElViN'.
	empty := ' '.
	self assert:  lc capitalized = uc.
	self assert: uc capitalized = uc.
	"the string gets copied"
	self deny: uc capitalized == uc.
	self deny: empty capitalized == empty.! !

!StringTest methodsFor: 'test-comparing' stamp: 'lr 7/7/2006 11:32'!
testComparing
	self assert: 'foo' < 'foo:'.
	self assert: 'foo' < 'fooBar'.
	self assert: 'foo' <= 'foo:'.
	self assert: 'foo' <= 'fooBar'.
	self assert: 'foo:' > 'foo'.
	self assert: 'fooBar' > 'foo'.
	self assert: 'foo:' >= 'foo'.
	self assert: 'fooBar' >= 'foo'! !

!StringTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!StringTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!StringTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!StringTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!StringTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!StringTest methodsFor: 'tests - copy' stamp: 'delaunay 3/30/2009 10:33'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!StringTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!StringTest methodsFor: 'testing - converting' stamp: 'nice 11/17/2009 11:16'!
testEncodeForHTTP

	self assert: 'aa aa  aa aa' encodeForHTTP = 'aa%20aa%20%C3%A9%C3%A9%20aa%20aa'! !

!StringTest methodsFor: 'testing' stamp: 'StephaneDucasse 2/3/2010 22:21'!
testEquality
	"self run: #testEquality"
	
	self assert: 'abc' = 'abc' asWideString.
	self assert: 'abc' asWideString = 'abc'.
	self assert: ( #[97 0 0 0] asString ~= 'a000' asWideString).
	self assert: ('a000' asWideString ~=  #[97 0 0 0] asString).

	self assert: ('abc' sameAs: 'aBc' asWideString).
	self assert: ('aBc' asWideString sameAs: 'abc').
	self assert: ( #[97 0 0 0] asString 
						sameAs: 'Abcd' asWideString) not.
	self assert: ('a000' asWideString sameAs: #[97 0 0 0] asString) not.! !

!StringTest methodsFor: 'tests - indexof' stamp: 'on 5/14/2008 13:27'!
testFindFirstInString
	
	"These tests are more specific than thsoe in testIndexOf."
	
	"more boundary tests"
	self assert: (self findFirstInString: '' fromString: '') = 0.
	self assert: (self findFirstInString: 'x' fromString: '') = 0.
	self assert: (self findFirstInString: '' fromString: 'x') = 0.
	
	self assert: (self findFirstInString: 'x' fromString: 'x') = 1. "<- FIXED"
	
	self assert: (self findFirstInString: 'hello' fromString: 'hello') = 1.
	self assert: (self findFirstInString: 'hello' fromString: 'ello') = 2.
	self assert: (self findFirstInString: 'hello' fromString: 'llo') = 3.
	self assert: (self findFirstInString: 'hello' fromString: 'o') = 5. "<- FIXED"
	self assert: (self findFirstInString: 'hello' fromString: 'x') = 0.
! !

!StringTest methodsFor: 'testing' stamp: 'nice 10/5/2009 03:44'!
testFindLastOccurenceOfStringStartingAt

	self assert: ('Smalltalk' findLastOccurrenceOfString: 'al' startingAt: 2) = 7.
	self assert: ('aaa' findLastOccurrenceOfString: 'aa' startingAt: 1) = 2.
	self assert: ('Smalltalk' asWideString findLastOccurrenceOfString: 'al' startingAt: 2) = 7.
	self assert: ('Smalltalk' asWideString findLastOccurrenceOfString: 'al' asWideString startingAt: 2) = 7.
	self assert: (('Smalltalk' copyWith: 835 asCharacter) findLastOccurrenceOfString: 'al' asWideString startingAt: 2) = 7.! !

!StringTest methodsFor: 'tests - iterate on sequenced reable collections' stamp: 'GuillermoPolito 5/23/2010 21:13'!
testFindSelector
	self assert: #isSymbol equals: 'isSymbol' findSelector.
	self assert: #between:and: equals: 'between:and:' findSelector .
	self assert: #+ equals: '+' findSelector .
	self assert: #isSymbol equals: '#isSymbol' findSelector.
	self assert: #between:and: equals: '#between:and:' findSelector .
	self assert:#+ equals: '#+' findSelector
! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy01

	| tokens |
	string := 'this, is, "a, test"'.
	tokens := string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'fbs 2/13/2006 22:20'!
testFindTokensEscapedBy02

	| tokens |
	string := ''.
	tokens := string findTokens: ',' escapedBy: '"'.
	self assert: tokens isEmpty! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy03

	| tokens |
	string := 'this, is, a, test'.
	tokens := string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 4! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy04

	| tokens |
	string := 'this, is, a"," test'.
	tokens := string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'fbs 2/13/2006 22:19'!
testFindTokensEscapedBy05

	| tokens |
	string := 'this, /is, a"," test/'.
	tokens := string findTokens: ',#' escapedBy: '"/'.
	self assert: tokens size = 2.
	self assert: tokens first = 'this'.
	self assert: tokens second = ' is, a"," test'.! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy06

	| tokens |
	string := 'this, is, "a, test'.
	tokens := string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy07

	| tokens |
	string := 'a:b::c'.
	tokens := string findTokens: ':' escapedBy: '"'.
	self assert: tokens size == 4.
	self assert: tokens first = 'a'.
	self assert: tokens second = 'b'.
	self assert: tokens third = ''.
	self assert: tokens fourth = 'c'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy08

	| tokens |
	string := 'this, is, ##a, test'.
	tokens := string findTokens: ',' escapedBy: '#'.
	self assert: tokens size == 4.
	self assert: tokens third = ' a'.
	self assert: tokens fourth = ' test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy09

	| tokens |
	string := 'this, is, ###a, test#'.
	tokens := string findTokens: ',' escapedBy: '#'.
	self assert: tokens size == 3.
	self assert: tokens third = ' #a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy10

	| tokens |
	string := 'this, is, ###a, test'.
	tokens := string findTokens: ',' escapedBy: '#'.
	self assert: tokens size == 3.
	self assert: tokens third = ' #a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy11

	| tokens |
	string := 'this, is, """a, test"'.
	tokens := string findTokens: ',' escapedBy: '"'.
	self assert: tokens size == 3.
	self assert: tokens third = ' "a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy12

	| tokens |
	string := 'one, two# three; four. five'.
	tokens := string findTokens: ',#;.' escapedBy: '"'.
	self assert: tokens size == 5.
	self assert: tokens third = ' three'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy13

	| tokens |
	string := 'one, two# three; four. five'.
	tokens := string findTokens: ',#;.' escapedBy: nil.
	self assert: tokens size == 5.
	self assert: tokens third = ' three'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy14

	| tokens |
	string := 'one, "two# three"; &four. five&'.
	tokens := string findTokens: ',#;.' escapedBy: '"&'.
	self assert: tokens size == 3.
	self assert: tokens second = ' two# three'.
	self assert: tokens third = ' four. five'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'fbs 2/13/2006 22:19'!
testFindTokensEscapedBy15

	| tokens |
	string := 'one, "two# three"; &four. five&'.
	tokens := string findTokens: nil escapedBy: '"&'.
	self assert: tokens size = 1.
	self assert: tokens first = 'one, two# three; four. five'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'fbs 2/13/2006 22:19'!
testFindTokensEscapedBy16

	| tokens |
	string := 'one, "two# three"; &four. five&'.
	tokens := string findTokens: nil escapedBy: nil.
	self assert: tokens size = 1.
	self assert: tokens first = string! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy21

	| tokens |
	string := 'this, is, "a, test"'.
	tokens := string findTokens: $, escapedBy: $".
	self assert: tokens size == 3! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'fbs 2/13/2006 22:19'!
testFindTokensEscapedBy22

	| tokens |
	string := ''.
	tokens := string findTokens: $, escapedBy: $".
	self assert: tokens size = 0! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy23

	| tokens |
	string := 'this, is, a, test'.
	tokens := string findTokens: $, escapedBy: $".
	self assert: tokens size == 4! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy24

	| tokens |
	string := 'this, is, a"," test'.
	tokens := string findTokens: $, escapedBy: $".
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'fbs 2/13/2006 22:19'!
testFindTokensEscapedBy25

	| tokens |
	string := 'this, /is, a"," test/'.
	tokens := string findTokens: $, escapedBy: $/.
	self assert: tokens size = 2.
	self assert: tokens first = 'this'.
	self assert: tokens second = ' is, a"," test'.! !

!StringTest methodsFor: 'testing - tokenizing' stamp: 'stephaneducasse 2/4/2006 20:10'!
testFindTokensEscapedBy26

	| tokens |
	string := 'this, is, "a, test'.
	tokens := string findTokens: $, escapedBy: $".
	self assert: tokens size == 3.
	self assert: tokens third = ' a, test'! !

!StringTest methodsFor: 'testing - formatting' stamp: 'nes 10/19/2009 16:49'!
testFormat

 	{ 
 		[ '\{ \} \\ foo {1} bar {2}' format: { 12. 'string' } ] -> '{ } \ foo 12 bar string'. 
 		[ '\{ \} \\ foo {2} bar {1}' format: { 'string'. 12 } ] -> '{ } \ foo 12 bar string'. 
 		[ '\{1}' format: {} ] -> '{1}'. 
 		[ '\{1}{1}' format: { $a } ] -> '{1}a'. 
 	} do: [ :each | self assert: each key value = each value ]! !

!StringTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAllOfNoneThere
	"self debug: #testIncludesAllOfNoneThere'"
	self deny: (self empty includesAllOf: self collection).
	self deny: (self nonEmpty includesAllOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!StringTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesAnyOfNoneThere
	"self debug: #testIncludesAnyOfNoneThere'"
	self deny: (self nonEmpty includesAnyOf: self empty).
	self deny: (self nonEmpty includesAnyOf: { 
				(self elementNotIn).
				(self anotherElementNotIn)
			 })! !

!StringTest methodsFor: 'tests - includes' stamp: 'delaunay 4/2/2009 11:53'!
testIncludesElementIsNotThere
	"self debug: #testIncludesElementIsNotThere"
	self deny: (self nonEmpty includes: self elementNotInForOccurrences).
	self assert: (self nonEmpty includes: self nonEmpty anyOne).
	self deny: (self empty includes: self elementNotInForOccurrences)! !

!StringTest methodsFor: 'tests - includes' stamp: 'delaunay 4/9/2009 10:44'!
testIncludesSubstringAnywhere
	"self debug: #testIncludesSubstringAnywher'"
	self assert: (self empty includesAllOf: self empty).
	self assert: (self nonEmpty includesAllOf: {  (self nonEmpty anyOne)  }).
	self assert: (self nonEmpty includesAllOf: self nonEmpty)! !

!StringTest methodsFor: 'tests - indexof' stamp: 'nice 3/15/2007 21:11'!
testIndexOf
	
	"test for http://bugs.impara.de/view.php?id=3574"
	self assert: ('abc-' asWideString indexOfAnyOf: (CharacterSet newFrom: ' -0123456789')) = 4.
	self assert: ('ab7' asWideString indexOfAnyOf: (CharacterSet newFrom: ' -0123456789')) = 3.
	self assert: ('a2c' asWideString indexOfAnyOf: (CharacterSet newFrom: ' -0123456789')) = 2.
	self assert: ('3bc' asWideString indexOfAnyOf: (CharacterSet newFrom: ' -0123456789')) = 1.
	self assert: ('abc' asWideString indexOfAnyOf: (CharacterSet newFrom: ' -0123456789')) = 0.
	
	"extension to wide characters"
	self assert: ((String with: 803 asCharacter with: 811 asCharacter) indexOfAnyOf: (CharacterSet newFrom: (String with: 811 asCharacter with: 812 asCharacter))) = 2.
	
	self assert: ('abc' indexOfAnyOf: (CharacterSet newFrom: (String with: 811 asCharacter with: 812 asCharacter))) = 0.
	
	self assert: ('abc' indexOfAnyOf: (CharacterSet newFrom: (String with: 811 asCharacter with: $c))) = 3.
	
	"make sure start index is used in wide string algorithm"
	self assert: ('ab bcd abc' copyWith: 811 asCharacter) substrings = {'ab'. 'bcd'. 'abc' copyWith: 811 asCharacter}.! !

!StringTest methodsFor: 'testing' stamp: 'StephaneDucasse 6/11/2010 12:35'!
testIsAllDigits
	"self run: #testIsAllDigits"
	self assert: '' isAllDigits = false.
	self assert: '1.23' isAllDigits = false.
	self assert: '12 3' isAllDigits = false.
	self assert: '-123' isAllDigits = false.
	self assert: '0123456789' isAllDigits = true.! !

!StringTest methodsFor: 'testing' stamp: 'StephaneDucasse 3/12/2011 16:30'!
testIsLiteralSymbol

	self assert: ('*+-/\~=<>&@%,|' allSatisfy: [:char | (Symbol with: char) isLiteralSymbol])
		description: 'single letter binary symbols can be printed without string quotes'.
		
	self assert: (#('x' 'x:' 'x:y:' 'from:to:by:' 'yourself') allSatisfy: [:str | str asSymbol isLiteralSymbol])
		description: 'valid ascii selector symbols can be printed without string quotes'.! !

!StringTest methodsFor: 'testing - lines' stamp: 'nice 11/16/2009 13:22'!
testLineCorrespondingToIndex
	| sampleCRString sampleLFString sampleCRLFString anIndex |
	sampleCRString := 'Fred', String cr , 'the' , String cr , 'Bear'.
	sampleLFString := 'Fred', String lf , 'the' , String lf , 'Bear'.
	sampleCRLFString := 'Fred', String crlf , 'the' , String crlf , 'Bear'.
	
	anIndex := sampleCRString indexOf: $h.
	self assert: (sampleCRString lineCorrespondingToIndex: anIndex) = 'the'.
	anIndex := sampleLFString indexOf: $h.
	self assert: (sampleLFString lineCorrespondingToIndex: anIndex) = 'the'.
	anIndex := sampleCRLFString indexOf: $h.
	self assert: (sampleCRLFString lineCorrespondingToIndex: anIndex) = 'the'.
	
	anIndex := sampleCRString indexOf: $B.
	self assert: (sampleCRString lineCorrespondingToIndex: anIndex) = 'Bear'.
	anIndex := sampleLFString indexOf: $B.
	self assert: (sampleLFString lineCorrespondingToIndex: anIndex) = 'Bear'.
	anIndex := sampleCRLFString indexOf: $B.
	self assert: (sampleCRLFString lineCorrespondingToIndex: anIndex) = 'Bear'.
	
	anIndex := sampleCRString indexOf: $d.
	self assert: (sampleCRString lineCorrespondingToIndex: anIndex) = 'Fred'.
	anIndex := sampleLFString indexOf: $d.
	self assert: (sampleLFString lineCorrespondingToIndex: anIndex) = 'Fred'.
	anIndex := sampleCRLFString indexOf: $d.
	self assert: (sampleCRLFString lineCorrespondingToIndex: anIndex) = 'Fred'.! !

!StringTest methodsFor: 'testing - lines' stamp: 'nice 11/16/2009 13:13'!
testLineCount
	| sampleCRString sampleLFString sampleCRLFString |
	sampleCRString := 'Fred', String cr , 'the' , String cr , 'Bear'.
	sampleLFString := 'Fred', String lf , 'the' , String lf , 'Bear'.
	sampleCRLFString := 'Fred', String crlf , 'the' , String crlf , 'Bear'.
	
	self assert: sampleCRString lineCount = 3.
	self assert: sampleLFString lineCount = 3.
	self assert: sampleCRLFString lineCount = 3.! !

!StringTest methodsFor: 'testing - lines' stamp: 'nice 11/16/2009 13:14'!
testLineNumber
	| sampleCRString sampleLFString sampleCRLFString |
	sampleCRString := 'Fred', String cr , 'the' , String cr , 'Bear'.
	sampleLFString := 'Fred', String lf , 'the' , String lf , 'Bear'.
	sampleCRLFString := 'Fred', String crlf , 'the' , String crlf , 'Bear'.
	
	self assert: (sampleCRString lineNumber: 2) = 'the'.
	self assert: (sampleLFString lineNumber: 2) = 'the'.
	self assert: (sampleCRLFString lineNumber: 2) = 'the'.! !

!StringTest methodsFor: 'testing - lines' stamp: 'nice 11/16/2009 13:19'!
testLinesDo
	| sampleCRString sampleLFString sampleCRLFString lines |
	sampleCRString := 'Fred', String cr , 'the' , String cr , 'Bear'.
	sampleLFString := 'Fred', String lf , 'the' , String lf , 'Bear'.
	sampleCRLFString := 'Fred', String crlf , 'the' , String crlf , 'Bear'.
	
	lines := OrderedCollection new.
	sampleCRString linesDo: [:aLine |
		self deny: (aLine includes: Character cr).
		self deny: (aLine includes: Character lf).
		lines add: aLine].
	self assert: lines asArray = #('Fred' 'the' 'Bear').
	
	lines := OrderedCollection new.
	sampleLFString linesDo: [:aLine |
		self deny: (aLine includes: Character cr).
		self deny: (aLine includes: Character lf).
		lines add: aLine].
	self assert: lines asArray = #('Fred' 'the' 'Bear').

	lines := OrderedCollection new.
	sampleCRLFString linesDo: [:aLine |
		self deny: (aLine includes: Character cr).
		self deny: (aLine includes: Character lf).
		lines add: aLine].
	self assert: lines asArray = #('Fred' 'the' 'Bear').

! !

!StringTest methodsFor: 'tests - line breaking' stamp: 'StephanEggermont 10/29/2009 09:18'!
testLinesDoWithCr

	| string newString |
	string := 'This is a test of line breaking', String cr.
	string linesDo: [ :line |
		self assert: ((line size + 1) = string size)]! !

!StringTest methodsFor: 'tests - line breaking' stamp: 'StephanEggermont 10/29/2009 09:20'!
testLinesDoWithCrBetween

	| string newString |
	string := ' This is a test ', String cr,'of line breaking'.
	string linesDo: [ :line |
		self assert: ((line size) = 16)]! !

!StringTest methodsFor: 'tests - line breaking' stamp: 'StephanEggermont 10/29/2009 09:42'!
testLinesDoWithCrLf

	| string newString |
	string := 'This is a test of line breaking', String crlf.
	string linesDo: [ :line |
		self assert: ((line size + 2) = string size)]! !

!StringTest methodsFor: 'tests - line breaking' stamp: 'StephanEggermont 10/29/2009 09:29'!
testLinesDoWithCrLfBetween

	| string newString |
	string := '-This is a test-', String crlf,'of line breaking'.
	string linesDo: [ :line |
		self assert: ((line size) = 16)]! !

!StringTest methodsFor: 'testing' stamp: 'nice 10/17/2008 23:53'!
testNumArgs
	"This is about http://code.google.com/p/pharo/issues/detail?id=237"
	
	self assert: ('*+-/\~=<>&@%,|' allSatisfy: [:char | (String with: char) numArgs = 1])
		description: 'binary selectors have 1 argument'.
		
	self assert: 'x' numArgs = 0
		description: 'unary selectors have 0 arguments'.
	self assert: 'x0' numArgs = 0
		description: 'unary selectors have 0 arguments'.
	self assert: 'yourself' numArgs = 0
		description: 'unary selectors have 0 arguments'.
		
	self assert: 'x:' numArgs = 1
		description: 'keyword selectors have as many elements as colons characters'.
	self assert: 'x:y:' numArgs = 2
		description: 'keyword selectors have as many elements as colons characters'.
	self assert: 'at:put:' numArgs = 2
		description: 'keyword selectors have as many elements as colons characters'.
		
	self assert: 'at:withoutTrailingColon' numArgs = -1
		description: 'keyword selectors should have a trailing colon character'.
		
	self assert: ':x' numArgs = -1
		description: 'keyword selectors cannot begin with a colon character'.
		
	self assert: 'x::y:' numArgs = -1
		description: 'keyword selectors cannot have two consecutive colon characters'.
	
	self assert: '0x' numArgs = -1
		description: 'selectors cannot begin with a digit'.
	
	"This one is known to fail...
	self assert: 'x:0:' numArgs = -1
		description: 'no keyword selector part can begin with a digit'.
	"
	
	! !

!StringTest methodsFor: 'testing - converting' stamp: 'KR 06/24/2005 11:21'!
testPercentEncodingJa
	| leading hiraA hiraO hiraAO encodedHiraA encodedHiraO encodedHiraAO |

    "Make Japanese String from unicode. see http://www.unicode.org/charts/PDF/U3040.pdf"
     leading := JapaneseEnvironment leadingChar.
	hiraA := (Character leadingChar: leading code: 16r3042) asString.  "HIRAGANA LETTER A"
	hiraO := (Character leadingChar: leading code: 16r304A) asString.  "HIRAGANA LETTER O"
	hiraAO := hiraA, hiraO.

	"Percent Encoded Japanese String"
	encodedHiraA := hiraA encodeForHTTP.
	self assert: encodedHiraA = '%E3%81%82'.
	encodedHiraO := hiraO encodeForHTTP.
	self assert: encodedHiraO = '%E3%81%8A'.
	encodedHiraAO := hiraAO encodeForHTTP.
	self assert: encodedHiraAO =  '%E3%81%82%E3%81%8A'.

     "without percent encoded string"
	self assert: '' unescapePercents = ''.
	self assert: 'abc' unescapePercents = 'abc'.	"latin1 character"
	self assert: hiraAO unescapePercents = hiraAO.  "multibyte character"

	"encoded latin1 string"
	self assert: '%61' unescapePercents = 'a'.
	self assert: '%61%62%63' unescapePercents = 'abc'.

	"encoded multibyte string"
	Locale currentPlatform: (Locale isoLanguage: 'ja') during: [ 
		self assert: encodedHiraA unescapePercents = hiraA.
		self assert: encodedHiraAO unescapePercents = hiraAO].

	"mixed string"
	Locale currentPlatform: (Locale isoLanguage: 'ja') during: [ 
		self assert: (encodedHiraAO,'a') unescapePercents = (hiraAO, 'a').
		self assert: ('a', encodedHiraA) unescapePercents = ('a', hiraA).
		self assert: ('a', encodedHiraA, 'b')  unescapePercents = ('a', hiraA, 'b').
		self assert: ('a', encodedHiraA, 'b', encodedHiraO) unescapePercents = ('a', hiraA, 'b', hiraO).
		self assert: (encodedHiraA, encodedHiraO, 'b', encodedHiraA) unescapePercents = (hiraA, hiraO, 'b', hiraA)].


	"for Seaside"
	Locale currentPlatform: (Locale isoLanguage: 'ja') during: [ 
		self assert: (encodedHiraA, '+', encodedHiraO) unescapePercents = (hiraA, ' ', hiraO)].

! !

!StringTest methodsFor: 'testing - instance creation' stamp: 'dc 3/21/2007 11:22'!
testSpace
	"self debug: #testSpace"
	
	string := String new.
	self assert: string size = 0. "instead of #isEmpty to be consistent with the following test"
	
	string := String space.
	self assert: string size = 1.
	self assert: string = ' '! !

!StringTest methodsFor: 'testing - converting' stamp: 'Pmm 12/5/2010 14:18'!
testSubStrings
	self assert: ('aba' subStrings: 'bc') isArray.
	self assert: ('aba' subStrings: 'bc') = #('a' 'a').
	self assert: ('abba' subStrings: 'bc') = #('a' 'a').
	self assert: ('babbab' subStrings: 'bc') = #('a' 'a').
	self assert: ('bbabbabb' subStrings: 'bc') = #('a' 'a').! !

!StringTest methodsFor: 'tests - converting' stamp: 'ky 7/8/2006 15:28'!
testUnescapePercents
	self assert: '' unescapePercents = ''.
	self assert: 'x' unescapePercents = 'x'.

	self assert: '+' unescapePercents = ' '.
	self assert: 'x+' unescapePercents = 'x '.
	self assert: '+x' unescapePercents = ' x'.
	self assert: 'x+x' unescapePercents = 'x x'.

	self assert: '%' unescapePercents = '%'.
	self assert: '%3' unescapePercents = '%3'.
	self assert: '%3C' unescapePercents = '<'.
	
	self assert: '%3Cx%3E4%3C%2Fx%3E' unescapePercents = '<x>4</x>'.
	
	self assert: '!!@#$%25%5E&*()%7B%7D%5B%5D=:/;?+''%22' unescapePercents  = '!!@#$%^&*(){}[]=:/;? ''"'.
	self assert: '!!%40%23%24%25%5E%26*()%7B%7D%5B%5D%3D%3A%2F%3B%3F%2B''%22' unescapePercents  = '!!@#$%^&*(){}[]=:/;?+''"'.
	self assert: '%21@%23%24%25%5E%26*%28%29%7B%7D%5B%5D%3D%3A/%3B%3F+%27%22' unescapePercents = '!!@#$%^&*(){}[]=:/;? ''"'! !

!StringTest methodsFor: 'tests - converting' stamp: 'ky 7/8/2006 18:01'!
testUnescapePercentsWithTextEncoding
	| leading kataTe kataSu kataTo |
	leading := JapaneseEnvironment leadingChar.
	"Katakana letter Te"
	kataTe := (Character leadingChar: leading code: 12486) asString.
	"Katakana letter Su"
	kataSu := (Character leadingChar: leading code: 12473) asString.
	"Katakana letter To"
	kataTo := (Character leadingChar: leading code: 12488) asString.
	self assert: ('%83e%83X%83g' unescapePercentsWithTextEncoding: 'shift_jis')
			= (kataTe , kataSu , kataTo).
	self assert: ('%83e%83X%83g%20and%20%83e%83X%83g' unescapePercentsWithTextEncoding: 'shift_jis')
			= (kataTe , kataSu , kataTo , ' and ' , kataTe , kataSu , kataTo)! !

!StringTest methodsFor: 'tests - converting' stamp: 'dc 4/10/2007 09:35'!
testUpTo
	"self debug: #testUpTo"
	self assert: #up:to: keywords = #(up: to:).
	self assert: #copy:from:to: keywords = #(copy: from: to:).
	self assert: #up keywords = #(up).
	self assert: #at: keywords = #(at:).
	! !

!StringTest methodsFor: 'testing - converting' stamp: 'StephaneDucasse 10/23/2009 13:08'!
testWithBlanksTrimmed 

	 | s | 
 	self assert: ' abc  d   ' withBlanksTrimmed = 'abc  d'. 
 	self assert: 'abc  d   ' withBlanksTrimmed = 'abc  d'. 
 	self assert: ' abc  d' withBlanksTrimmed = 'abc  d'. 
 	self assert: (((0 to: 255) collect: [ :each |  each asCharacter ] thenSelect: [ :each | each 
		isSeparator ]) as: String) withBlanksTrimmed = ''. 
 	s := 'abcd'. 
 	self assert: s withBlanksTrimmed = s. 
 ! !

!StringTest methodsFor: 'tests - converting' stamp: 'sd 6/5/2005 09:27'!
testWithFirstCharacterDownshifted

	| uc lc empty |		
	uc := 'MElViN'.
	lc := 'mElViN'.
	empty := ' '.
	self assert:  uc withFirstCharacterDownshifted = lc.
	self assert: lc withFirstCharacterDownshifted = lc.
	"the string gets copied"
	self deny: lc withFirstCharacterDownshifted == lc.
	self deny: empty withFirstCharacterDownshifted == empty.! !

!StringTest methodsFor: 'testing - internet' stamp: 'ul 11/23/2009 14:39'!
testWithInternetLineEndings

	{
		'abc' -> 'abc'.
		'abc', String cr -> ('abc', String crlf).
		'abc', String lf -> ('abc', String crlf).
		'abc', String crlf -> ('abc', String crlf).
		String cr, 'abc' -> (String crlf, 'abc').
		String lf, 'abc' -> (String crlf, 'abc').
		String crlf, 'abc' -> (String crlf, 'abc').
		'abc', String cr, String cr, 'abc' -> ('abc', String crlf, String crlf, 'abc').
		'abc', String lf, String lf, 'abc' -> ('abc', String crlf, String crlf, 'abc').
		'abc', String crlf, String crlf, 'abc' -> ('abc', String crlf, String crlf, 'abc').
		String cr, 'abc', String cr, String crlf, 'abc', String lf -> (String crlf, 'abc', String crlf, String crlf, 'abc', String crlf).
		String lf, 'abc', String lf, String crlf, 'abc', String cr -> (String crlf, 'abc', String crlf, String crlf, 'abc', String crlf).
	} do: [ :each |
		self assert: each key withInternetLineEndings = each value ]! !

!StringTest methodsFor: 'testing - internet' stamp: 'nice 1/18/2010 23:33'!
testWithSqueakLineEndings

	{
		'abc' -> 'abc'.
		'abc', String cr -> ('abc', String cr).
		'abc', String lf -> ('abc', String cr).
		'abc', String crlf -> ('abc', String cr).
		String cr, 'abc' -> (String cr, 'abc').
		String lf, 'abc' -> (String cr, 'abc').
		String crlf, 'abc' -> (String cr, 'abc').
		'abc', String cr, String cr, 'abc' -> ('abc', String cr, String cr, 'abc').
		'abc', String lf, String lf, 'abc' -> ('abc', String cr, String cr, 'abc').
		'abc', String crlf, String crlf, 'abc' -> ('abc', String cr, String cr, 'abc').
		String cr, 'abc', String cr, String crlf, 'abc', String lf -> (String cr, 'abc', String cr, String cr, 'abc', String cr).
		String lf, 'abc', String lf, String crlf, 'abc', String cr -> (String cr, 'abc', String cr, String cr, 'abc', String cr).
	} do: [ :each |
		self assert: each key withSqueakLineEndings = each value ]! !

!StringTest methodsFor: 'testing - internet' stamp: 'nice 1/18/2010 23:35'!
testWithUnixLineEndings

	{
		'abc' -> 'abc'.
		'abc', String cr -> ('abc', String lf).
		'abc', String lf -> ('abc', String lf).
		'abc', String crlf -> ('abc', String lf).
		String cr, 'abc' -> (String lf, 'abc').
		String lf, 'abc' -> (String lf, 'abc').
		String crlf, 'abc' -> (String lf, 'abc').
		'abc', String cr, String cr, 'abc' -> ('abc', String lf, String lf, 'abc').
		'abc', String lf, String lf, 'abc' -> ('abc', String lf, String lf, 'abc').
		'abc', String crlf, String crlf, 'abc' -> ('abc', String lf, String lf, 'abc').
		String cr, 'abc', String cr, String crlf, 'abc', String lf -> (String lf, 'abc', String lf, String lf, 'abc', String lf).
		String lf, 'abc', String lf, String crlf, 'abc', String cr -> (String lf, 'abc', String lf, String lf, 'abc', String lf).
	} do: [ :each |
		self assert: each key withUnixLineEndings = each value ]! !

!StringTest methodsFor: 'tests - converting' stamp: 'Henrik Sperre Johansen 8/13/2009 12:38'!
testWriteStreamConvertsToWideString
	| oldWideString string ws |
	"test that a write stream on a ByteString is autoconverted into a WideString if a Wide character is inserted into it"
	oldWideString := (WideString new: 1) wordAt: 1 
										put: 20984060; 
										yourself.
	string := (String new: oldWideString size).
	ws := string writeStream.
	oldWideString do: [:each | ws nextPut: each].
	self assert: (string = oldWideString).! !

!StringTest methodsFor: 'testing - lines' stamp: 'nice 11/16/2009 22:26'!
testWthNoLineLongerThan
	| phrases |
	phrases := {
		'Fred the bear went down to the brook to read his book in silence'.
		'Fred the bear went down' , String cr , ' to the brook to ' , String cr , 'read his book in silence'.
		'Fred the bear went down' , String lf , '  to the brook to ' , String lf , 'read his book in silence'.
		'Fred the bear went down' , String crlf , '  to the brook to ' , String crlf , 'read his book in silence'.
		}.
	#(5 7 9) do: [:length |
		phrases do: [:phrase |
			| split |
			split := phrase withNoLineLongerThan: length.
			self
				assert: (split copyWithoutAll: CharacterSet separators) = (phrase copyWithoutAll: CharacterSet separators)
				description: 'no information should be lost'.
			split linesDo: [:line |
				self assert: line size <= length description: 'lines should not be longer than prescribed'].
			phrase lineCount = 1 ifTrue: [| lastLineSize |
				lastLineSize := length.
				split linesDo: [:line |
					line isEmpty ifFalse: [| firstWordSize |
						firstWordSize := line indexOfAnyOf: CharacterSet separators startingAt: 1 ifAbsent: [line size + 1].
						self assert: (lastLineSize + firstWordSize) > length description: 'split was too short'.
						lastLineSize := line size]]]]]! !

!StringTest methodsFor: 'tests - converting' stamp: 'md 2/5/2007 15:21'!
testZipped
	| compressed |
	
	compressed := 'hello' zipped.
	self assert: (compressed unzipped = 'hello').! !

!StringTest methodsFor: 'testing - converting' stamp: 'StephaneDucasse 9/18/2010 21:22'!
testindexOfstartingAt

	self assert: ('aa aa  aa aa' indexOf: $a startingAt: 8) = 10.
	self assert: ('aa aa  aa aa' indexOf: $z startingAt: 8) = 0.! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 5/11/2009 16:54'!
unsortedCollection
	^ unsortedCollection ! !

!StringTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 14:30'!
withEqualElements
	" return a collection  including equal elements (classic equality)"
	^ sameAtEndAndBegining 	! !

CollectionRootTest subclass: #SymbolTest
	uses: TIncludesTest + TCloneTest - {#testCopyCreatesNewObject} + TCopyPreservingIdentityTest + TCopyTest + TSetArithmetic - {#testDifferenceWithNonNullIntersection} + TIterateSequencedReadableTest + TSequencedConcatenationTest + TPrintOnSequencedTest + TAsStringCommaAndDelimiterSequenceableTest + TIndexAccess + TIndexAccessForMultipliness - {#testIdentityIndexOfIAbsentDuplicate. #testIdentityIndexOfDuplicate. #collectionWithNonIdentitySameAtEndAndBegining} + TSequencedElementAccessTest + TSubCollectionAccess + TCopySequenceableSameContents - {#testShuffled} + TCopyPartOfSequenceable - {#testCopyEmptyMethod. #integerCollectionWithoutEqualElements} + TCopyPartOfSequenceableForMultipliness + TCopySequenceableWithReplacement + TBeginsEndsWith + TConvertAsSortedTest + TConvertTest - {#testAsByteArray} + TCopySequenceableWithOrWithoutSpecificElements + TConvertAsSetForMultiplinessTest + TSequencedStructuralEqualityTest + TOccurrencesForMultiplinessTest
	instanceVariableNames: 'emptySymbol nonEmptySymbol5ElementsNoDuplicates notIn collectionNotIncluded collectionSize4 collection1Element sameAtEndAndBegining with2timeSubcollection subcollection3ElementsSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-Strings'!

!SymbolTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Symbol. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- there is a chapter in the PharoByExample book (http://pharobyexample.org/)
	- the sunit class category!

SymbolTest class
	uses: TIncludesTest classTrait + TCloneTest classTrait + TCopyPreservingIdentityTest classTrait + TCopyTest classTrait + TSetArithmetic classTrait + TIterateSequencedReadableTest classTrait + TSequencedConcatenationTest classTrait + TPrintOnSequencedTest classTrait + TAsStringCommaAndDelimiterSequenceableTest classTrait + TIndexAccess classTrait + TIndexAccessForMultipliness classTrait + TSequencedElementAccessTest classTrait + TSubCollectionAccess classTrait + TCopySequenceableSameContents classTrait + TCopyPartOfSequenceable classTrait + TCopyPartOfSequenceableForMultipliness classTrait + TCopySequenceableWithReplacement classTrait + TBeginsEndsWith classTrait + TConvertAsSortedTest classTrait + TConvertTest classTrait + TCopySequenceableWithOrWithoutSpecificElements classTrait + TConvertAsSetForMultiplinessTest classTrait + TSequencedStructuralEqualityTest classTrait + TOccurrencesForMultiplinessTest classTrait
	instanceVariableNames: ''!

SymbolTest subclass: #ByteSymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-Strings'!

!ByteSymbolTest methodsFor: 'test - creation' stamp: 'SheridanMahoney 12/6/2009 17:39'!
testAs
	"self debug: #testAs"

| tStr tAs1 tAs2 |

tStr := DateAndTime now asString .
tAs1 :=  tStr as: ByteSymbol . 
self assert: 	(Symbol allSymbols select: [:e | e asString  = tStr ]  ) size = 1 .
self assert: 	(ByteSymbol allInstances select: [:e | e asString = tStr] ) size = 1 .  
self assert: 	(ByteSymbol allInstances select: [:e | e asString = tStr] ) =
		(Symbol allSymbols select: [:e | e asString  = tStr ]  ) .
		
tAs2 :=  tStr as: ByteSymbol . 
self assert: 	(Symbol allSymbols select: [:e | e asString  = tStr ]  ) size = 1 .
self assert: 	(ByteSymbol allInstances select: [:e | e asString = tStr] ) size = 1 .  

! !

!ByteSymbolTest methodsFor: 'test - non-creation' stamp: 'SheridanMahoney 12/2/2009 17:14'!
testNew
	"self debug: #testNew"

	
	self should: [ByteSymbol new: 5 ] raise: TestResult error. ! !

!ByteSymbolTest methodsFor: 'test - creation' stamp: 'SheridanMahoney 12/6/2009 17:38'!
testNewFrom
	"self debug: #testNewFrom"

| dt newFrom1 newFrom2 |

dt := DateAndTime now asString .
newFrom1 := ByteSymbol newFrom: dt .

self assert:
	(Symbol allSymbols select: [:e | e asString  = dt  ]  ) size = 1 .
self assert:
	(ByteSymbol allInstances select: [:e | e = dt  ] ) size = 1 .
self assert:
	(Symbol allSymbols select: [:e | e asString  = dt  ]  ) =
			(ByteSymbol allInstances select: [:e | e = dt ] ) .
			
newFrom2 := ByteSymbol newFrom: dt . 
self assert:
	(Symbol allSymbols select: [:e | e asString  = dt  ]  ) size = 1 .
self assert:
	(ByteSymbol allInstances select: [:e | e = dt ] ) size = 1 .
	! !

!ByteSymbolTest methodsFor: 'test - creation' stamp: 'SheridanMahoney 12/6/2009 19:02'!
testReadFromString
	"self debug: #testReadFromString"

| str strWithPound readFrom1 readFrom2 |
Smalltalk garbageCollect. 
str := 'notYetExisting' .
self assert: (Symbol allSymbols select: [:e | e asString  = str ]  ) size = 0 .
self assert: (ByteSymbol allInstances select: [:e | e asString = str] ) size = 0 .  
strWithPound := ('#' , str) .
readFrom1 := ByteSymbol readFromString: strWithPound .
self assert:	(Symbol allSymbols select: [:e | e asString  = str  ]  ) size = 1 .
self assert:	(ByteSymbol allInstances select: [:e | e = str ] ) size = 1 .
self assert:	(Symbol allSymbols select: [:e | e asString  = str  ]  ) =
			(ByteSymbol allInstances select: [:e | e = str ] ) .
			
readFrom2  := ByteSymbol readFromString: strWithPound .
self assert:
	(Symbol allSymbols select: [:e | e asString  = str  ]  ) size = 1 .
self assert:
	(ByteSymbol allInstances select: [:e | e = str ] ) size = 1 .! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:49'!
anotherElementNotIn
	^ notIn ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:02'!
anotherElementOrAssociationIn
	" return an element (or an association for Dictionary ) present  in 'collection' "
	^ self collection anyOne! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/29/2009 12:03'!
anotherElementOrAssociationNotIn
	" return an element (or an association for Dictionary )not present  in 'collection' "
	^ notIn ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:49'!
collection

	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'test - set arithmetic' stamp: 'stephane.ducasse 12/20/2008 21:57'!
collectionClass

	^ Symbol! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:10'!
collectionMoreThan1NoDuplicates
	" return a collection of size > 1 without equal elements"
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:45'!
collectionNotIncluded
" return a collection for wich each element is not included in 'nonEmpty' "
	^ collectionNotIncluded ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:39'!
collectionWith1TimeSubcollection
" return a collection including 'oldSubCollection'  only one time "
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:41'!
collectionWith2TimeSubcollection
" return a collection including 'oldSubCollection'  two or many time "
	^ with2timeSubcollection ! !

!SymbolTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:45'!
collectionWithElementsToRemove
" return a collection of elements included in 'nonEmpty'  "
	^ subcollection3ElementsSorted  ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:00'!
collectionWithEqualElements
" return a collecition including atLeast two elements equal"

^ sameAtEndAndBegining .! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:13'!
collectionWithSameAtEndAndBegining
	" return a collection with elements at end and begining equals .
(others elements of the collection are not equal to those elements)"
	^ sameAtEndAndBegining ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:20'!
collectionWithSortableElements
	" return a collection only including elements that can be sorted (understanding '<' )"
	^ nonEmptySymbol5ElementsNoDuplicates .! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:55'!
collectionWithoutEqualElements
" return a collection without equal elements"
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:36'!
collectionWithoutEqualsElements

" return a collection not including equal elements "
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:56'!
collectionWithoutNilElements
" return a collection that doesn't includes a nil element  and that doesn't includes equal elements'"
	^nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:15'!
elementInForElementAccessing
" return an element inculded in 'moreThan4Elements'"
	^ self moreThan4Elements anyOne! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:11'!
elementInForIndexAccessing
" return an element included in 'collectionMoreThan1NoDuplicates' "
	^ self collectionMoreThan1NoDuplicates anyOne.! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:45'!
elementNotIn
"return an element not included in 'nonEmpty' "

	^ notIn ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:15'!
elementNotInForElementAccessing
" return an element not included in 'moreThan4Elements' "
	^ notIn ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:11'!
elementNotInForIndexAccessing
" return an element not included in 'collectionMoreThan1NoDuplicates' "
	^ notIn ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:56'!
elementNotInForOccurrences
	^ notIn ! !

!SymbolTest methodsFor: 'test - copy' stamp: 'delaunay 4/17/2009 15:26'!
elementToAdd
	^ $u! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 5/13/2009 16:00'!
elementTwiceInForOccurrences
" return an element included exactly two time in # collectionWithEqualElements"
^ sameAtEndAndBegining first! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:49'!
empty
	^ emptySymbol ! !

!SymbolTest methodsFor: 'testing' stamp: 'StephaneDucasse 3/12/2011 16:30'!
expectedBehavior
	| result |
	
	^result := { 
		[Symbol readFromString: '#''abc'''] -> #abc.
		[Symbol readFromString: '#ab-C'] -> #ab.
	 	[Symbol readFromString: '#abC'] -> #abC. 
		[Symbol readFromString: '#ab@c'] -> #ab}.! !

!SymbolTest methodsFor: 'testing' stamp: 'HenrikSperreJohansen 10/18/2009 11:17'!
expectedFailures
	"Symbols are unique"
	^#(#testCopyNotSame)! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:00'!
firstCollection
" return a collection that will be the first part of the concatenation"
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:37'!
indexInForCollectionWithoutDuplicates
" return an index between 'collectionWithoutEqualsElements'  bounds"
	^ 2! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 16:17'!
indexInNonEmpty
" return an index between bounds of 'nonEmpty' "

	^ 2! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:17'!
moreThan3Elements
	" return a collection including atLeast 3 elements"
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:15'!
moreThan4Elements

" return a collection including at leat 4 elements"
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:49'!
nonEmpty
	^ nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:02'!
nonEmpty1Element
" return a collection of size 1 including one element"
	^collection1Element ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:59'!
nonEmptyMoreThan1Element
" return a collection that don't includes equal elements'" 
	^nonEmptySymbol5ElementsNoDuplicates ! !

!SymbolTest methodsFor: 'requirements' stamp: 'cyrille.delaunay 12/18/2009 13:45'!
oldSubCollection
" return a subCollection included in collectionWith1TimeSubcollection .
ex :   subCollection := #( 2 3 4) and collectionWith1TimeSubcollection := #(1 2 3 4 5)"
	^ subcollection3ElementsSorted  ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:39'!
replacementCollection
" return a collection that will be used to replace 'oldSubcollection' in ' collectionWith1TimeSubcollection'  " 
	^ collection1Element ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:00'!
secondCollection
" return a collection that will be the second part of the concatenation"
	^ collectionSize4 ! !

!SymbolTest methodsFor: 'setup' stamp: 'cyrille.delaunay 12/18/2009 13:44'!
setUp
	emptySymbol := #''.
	collectionSize4 := #abcd.
	collection1Element := #a.
	subcollection3ElementsSorted := #bcd.
	with2timeSubcollection := #abcdebcda.
	nonEmptySymbol5ElementsNoDuplicates := #abcde.
	sameAtEndAndBegining := #abcda.
	notIn := $z.
	collectionNotIncluded := #zz.! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 14:58'!
sizeCollection
	"Answers a collection whose #size is 4"
	^ collectionSize4 ! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/27/2009 15:16'!
subCollectionNotIn
" return a collection for which at least one element is not included in 'moreThan4Elements' "
	^ collectionNotIncluded ! !

!SymbolTest methodsFor: 'tests' stamp: 'md 9/6/2005 20:02'!
testAsMutator

	self assert: #x asMutator = #x:.
	self assert: #x asMutator isSymbol! !

!SymbolTest methodsFor: 'tests - as sorted collection' stamp: 'hfm 4/2/2010 13:41'!
testAsSortedArray
	| result collection |
	collection := self collectionWithSortableElements .
	result := collection  asArray sort.
	self assert: (result class includesBehavior: Array).
	self assert: result isSorted.
	self assert: result size = collection size! !

!SymbolTest methodsFor: 'tests' stamp: 'sd 6/5/2005 09:29'!
testCapitalized

	| uc lc |		
	uc := #MElViN.
	lc := #mElViN.
	self assert:  lc capitalized = uc.
	self assert: uc capitalized = uc.
! !

!SymbolTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWith
	"self debug: #testCopyWith"
	| res |
	res := self empty copyWith: self elementToAdd.
	self assert: res size = (self empty size + 1).
	self assert: (res includes: self elementToAdd)! !

!SymbolTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyEmptyWithout
	"self debug: #testCopyEmptyWithout"
	| res |
	res := self empty copyWithout: self elementToAdd.
	self assert: res size = self empty size.
	self deny: (res includes: self elementToAdd)! !

!SymbolTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyEmptyWithoutAll
	"self debug: #testCopyEmptyWithoutAll"
	| res |
	res := self empty copyWithoutAll: self collectionWithElementsToRemove.
	self assert: res size = self empty size.
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ]! !

!SymbolTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWith
	"self debug: #testCopyNonEmptyWith"
	| res |
	res := self nonEmpty copyWith: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self assert: (res includes: self elementToAdd).
	self nonEmpty do: [ :each | res includes: each ]! !

!SymbolTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:24'!
testCopyNonEmptyWithoutAll
	"self debug: #testCopyNonEmptyWithoutAll"
	| res |
	res := self nonEmpty copyWithoutAll: self collectionWithElementsToRemove.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self collectionWithElementsToRemove do: [ :each | self deny: (res includes: each) ].
	self nonEmpty do: 
		[ :each | 
		(self collectionWithElementsToRemove includes: each) ifFalse: [ self assert: (res includes: each) ] ]! !

!SymbolTest methodsFor: 'tests - copy' stamp: 'delaunay 3/30/2009 10:33'!
testCopyNonEmptyWithoutAllNotIncluded
	! !

!SymbolTest methodsFor: 'tests - copy' stamp: 'delaunay 4/17/2009 15:26'!
testCopyNonEmptyWithoutNotIncluded
	"self debug: #testCopyNonEmptyWithoutNotIncluded"
	| res |
	res := self nonEmpty copyWithout: self elementToAdd.
	"here we do not test the size since for a non empty set we would get a problem.
	Then in addition copy is not about duplicate management. The element should 
	be in at the end."
	self nonEmpty do: [ :each | self assert: (res includes: each) ]! !

!SymbolTest methodsFor: 'testing' stamp: 'StephaneDucasse 3/12/2011 16:30'!
testIsLiteralSymbol

	self assert: ('*+-/\~=<>&@%,|' allSatisfy: [:char | (Symbol with: char) isLiteralSymbol])
		description: 'single letter binary symbols can be printed without string quotes'.
		
	self assert: (#('x' 'x:' 'x:y:' 'from:to:by:' 'yourself') allSatisfy: [:str | str asSymbol isLiteralSymbol])
		description: 'valid ascii selector symbols can be printed without string quotes'.! !

!SymbolTest methodsFor: 'requirements' stamp: 'SheridanMahoney 12/4/2009 20:12'!
testNew
	"self debug: #testNew"

	
	self should: [Symbol new: 5 ] raise: TestResult error. ! !

!SymbolTest methodsFor: 'tests' stamp: 'md 2/16/2006 17:17'!
testNumArgs2
    "TODO: need to be extended to support shrinking and for selectors like #+ " 
	
	self assert: (#test numArgs: 0) = #test.
	self assert: (#test numArgs: 1) = #test:.
	self assert: (#test numArgs: 2) = #test:with:.
	self assert: (#test numArgs: 3) = #test:with:with:.
	

	self assert: (#test: numArgs: 0) = #test:.
	self assert: (#test: numArgs: 1) = #test:.
	self assert: (#test: numArgs: 2) = #test:with:.
	self assert: (#test: numArgs: 3) = #test:with:with:.
	
	self assert: (#test:with: numArgs: 0) = #test:with:.
	self assert: (#test:with: numArgs: 1) = #test:with:.
	self assert: (#test:with: numArgs: 2) = #test:with:.
	self assert: (#test:with: numArgs: 3) = #test:with:with:.
	self assert: (#test:with: numArgs: 4) = #test:with:with:with:.
	
	self assert: (#test:with:with: numArgs: 0) = #test:with:with:.
	self assert: (#test:with:with: numArgs: 1) = #test:with:with:.
	self assert: (#test:with:with: numArgs: 2) = #test:with:with:.
	self assert: (#test:with:with: numArgs: 3) = #test:with:with:.
	self assert: (#test:with:with: numArgs: 4) = #test:with:with:with:.! !

!SymbolTest methodsFor: 'tests' stamp: 'LukasRenggli 8/22/2010 17:33'!
testNumArgsBinary
	self assert: ('-' numArgs = 1).
	self assert: ('++' numArgs = 1).
	self assert: ('*&@' numArgs = 1).
	
	self assert: (' ++' numArgs = -1).
	self assert: ('+ +' numArgs = -1).
	self assert: ('++ ' numArgs = -1).

	self assert: ('_++' numArgs = -1).
	self assert: ('+_+' numArgs = -1).
	self assert: ('++_' numArgs = -1).
	
	self assert: ('1' numArgs = -1).
	self assert: ('*a' numArgs = -1)! !

!SymbolTest methodsFor: 'tests' stamp: 'LukasRenggli 8/22/2010 17:38'!
testNumArgsKeyword1
	self assert: ('name:' numArgs = 1).

	self assert: ('name_:' numArgs = 1).
	self assert: ('_name:' numArgs = 1).
	self assert: ('na_me:' numArgs = 1).

	self assert: ('name: ' numArgs = -1).
	self assert: (' name:' numArgs = -1).
	self assert: ('na me:' numArgs = -1).
	
	self assert: ('name+:' numArgs = -1).
	self assert: ('+name:' numArgs = -1).
	self assert: ('na+me:' numArgs = -1).
	
	self assert: ('name123:' numArgs = 1).
	self assert: ('na123me:' numArgs = 1).
	self assert: ('123name:' numArgs = -1)! !

!SymbolTest methodsFor: 'tests' stamp: 'LukasRenggli 8/22/2010 17:41'!
testNumArgsKeyword2
	self assert: ('name:with:' numArgs = 2).

	self assert: ('_name:with:' numArgs = 2).
	self assert: ('na_me:with:' numArgs = 2).
	self assert: ('name_:with:' numArgs = 2).
	
	self assert: ('name:_with:' numArgs = 2).
	self assert: ('name:wi_th:' numArgs = 2).
	self assert: ('name:with_:' numArgs = 2).
	
	self assert: ('name:with: ' numArgs = -1).
	self assert: ('name: with:' numArgs = -1).
	self assert: (' name:with:' numArgs = -1).
	
	self assert: ('name+:with:' numArgs = -1).
	self assert: ('+name:with:' numArgs = -1).
	self assert: ('na+me:with:' numArgs = -1).
	
	self assert: ('123name:with:' numArgs = -1).
	self assert: ('name123:with:' numArgs = 2).
	self assert: ('name:123with:' numArgs = 2).
	self assert: ('name:with123:' numArgs = 2)! !

!SymbolTest methodsFor: 'tests' stamp: 'LukasRenggli 8/22/2010 17:32'!
testNumArgsUnary
	self assert: ('name' numArgs = 0).

	self assert: ('name_' numArgs = 0).
	self assert: ('_name' numArgs = 0).
	self assert: ('na_me' numArgs = 0).

	self assert: ('name ' numArgs = -1).
	self assert: (' name' numArgs = -1).
	self assert: ('na me' numArgs = -1).
	
	self assert: ('name+' numArgs = -1).
	self assert: ('+name' numArgs = -1).
	self assert: ('na+me' numArgs = -1).
	
	self assert: ('name123' numArgs = 0).
	self assert: ('na123me' numArgs = 0).
	self assert: ('123name' numArgs = -1)! !

!SymbolTest methodsFor: 'testing' stamp: 'StephaneDucasse 3/12/2011 16:31'!
testReadFrom

	self expectedBehavior do: [:association |
		self assert: (association key value == association value)]! !

!SymbolTest methodsFor: 'tests' stamp: 'sd 6/5/2005 09:29'!
testWithFirstCharacterDownshifted

	| uc lc empty |		
	uc := #MElViN.
	lc := #mElViN.
	empty := #' '.
	self assert:  uc withFirstCharacterDownshifted = lc.
	self assert: lc withFirstCharacterDownshifted = lc.
	
! !

!SymbolTest methodsFor: 'requirements' stamp: 'delaunay 4/28/2009 14:30'!
withEqualElements
	" return a collection  including equal elements (classic equality)"
	^ sameAtEndAndBegining ! !

ClassTestCase subclass: #CharacterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-Strings'!

!CharacterTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class Character. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- there is a chapter in the PharoByExample book (http://pharobyexample.org/)
	- the sunit class category!

!CharacterTest methodsFor: 'tests' stamp: 'StephaneDucasse 3/30/2010 18:34'!
testCodePoint

	self assert: $A codePoint = 65.
	self assert: (Character codePoint: $a codePoint) = $a.
	self assert: (Character codePoint: 97) codePoint = 97.! !

!CharacterTest methodsFor: 'tests' stamp: 'StephaneDucasse 3/28/2010 19:19'!
testDigitValue
	"self debug: #testDigitValue"
	
	'0123456789ABCDEF' with: #(0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15)
		do: [:char :value | self assert: char digitValue = value].
	
	'0123456789' with: #(0 1 2 3 4 5 6 7 8 9)
		do: [:char :value | self assert: char digitValue = value].
		
	 ! !

!CharacterTest methodsFor: 'tests' stamp: 'StephaneDucasse 7/31/2010 19:40'!
testHex
	self assert: $a hex = '16r61'.
	self assert: Character space hex = '16r20'! !

!CharacterTest methodsFor: 'tests instance creation' stamp: 'GabrielOmarCotelli 5/29/2009 23:43'!
testInstanceCreation

	self should: [ Character value: -1] raise: Error.
	
	self shouldnt: [Character value: 0] raise: Error.
	self shouldnt: [Character value: 256] raise: Error! !

!CharacterTest methodsFor: 'tests instance creation' stamp: 'sd 6/5/2005 09:25'!
testNew

	self should: [Character new] raise: Error.! !

!CharacterTest methodsFor: 'tests' stamp: 'lr 11/21/2005 17:41'!
testPrintString
	self assert: $a printString = '$a'.
	self assert: $5 printString = '$5'.
	self assert: $@ printString = '$@'.

	self assert: Character cr printString = 'Character cr'.
	self assert: Character lf printString = 'Character lf'.
	self assert: Character space printString = 'Character space'.

	self assert: (Character value: 0) printString = 'Character value: 0'.
	self assert: (Character value: 17) printString = 'Character value: 17'.! !

!CharacterTest methodsFor: 'tests' stamp: 'lr 11/21/2005 17:41'!
testPrintStringAll
	Character allCharacters do: [ :each |
		self assert: (self class compilerClass 
			evaluate: each printString) = each ].! !

!CharacterTest methodsFor: 'tests' stamp: 'StephaneDucasse 7/31/2010 19:47'!
testPrintStringHex
	self assert: $a printStringHex = '61'.
	self assert: Character space printStringHex = '20'! !

!CharacterTest methodsFor: 'tests' stamp: 'lr 11/21/2005 17:22'!
testStoreString
	self assert: $a storeString = '$a'.
	self assert: $5 storeString = '$5'.
	self assert: $@ storeString = '$@'.

	self assert: Character cr storeString = 'Character cr'.
	self assert: Character lf storeString = 'Character lf'.
	self assert: Character space storeString = 'Character space'.

	self assert: (Character value: 0) storeString = '(Character value: 0)'.
	self assert: (Character value: 17) storeString = '(Character value: 17)'.! !

!CharacterTest methodsFor: 'tests' stamp: 'lr 11/21/2005 17:24'!
testStoreStringAll
	Character allCharacters do: [ :each |
		self assert: (self class compilerClass 
			evaluate: each storeString) = each ].! !

ClassTestCase subclass: #WideStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Tests-Strings'!

!WideStringTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class String. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- there is a chapter in the PharoByExample book (http://pharobyexample.org/)
	- the sunit class category!

!WideStringTest methodsFor: 'tests - converting' stamp: 'ar 4/12/2005 17:36'!
testAsInteger
	self assert: '1796exportFixes-tkMX' asWideString asInteger = 1796.
	self assert: 'donald' asWideString asInteger isNil.
	self assert: 'abc234def567' asWideString asInteger = 234.
	self assert: '-94' asWideString asInteger = -94.
	self assert: 'foo-bar-92' asWideString asInteger = -92.

	self assert: '1796exportFixes-tkMX' asWideString asSignedInteger = 1796.
	self assert: 'donald' asWideString asSignedInteger isNil.
	self assert: 'abc234def567' asWideString asSignedInteger = 234.
	self assert: '-94' asWideString asSignedInteger = -94.
	self assert: 'foo-bar-92' asWideString asSignedInteger = -92.

	self assert: '1796exportFixes-tkMX' asWideString asUnsignedInteger = 1796.
	self assert: 'donald' asWideString asUnsignedInteger isNil.
	self assert: 'abc234def567' asWideString asUnsignedInteger = 234.
	self assert: '-94' asWideString asUnsignedInteger = 94.
	self assert: 'foo-bar-92' asWideString asUnsignedInteger = 92! !

!WideStringTest methodsFor: 'testing' stamp: 'nice 4/2/2008 23:49'!
testAtPut
	"Non regression test for http://bugs.squeak.org/view.php?id=6998"
	
	| w1 |
	w1 := WideString with: (Unicode value: 402) with: $a with: (Unicode value: 400) with: $b.
	self assert: (w1 at: 2 put: $b) = $b description: 'at:put: should return the put-object'
! !

!WideStringTest methodsFor: 'tests - beginswith' stamp: 'nice 7/28/2007 23:29'!
testBeginsWith
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"
	
	| w1 w2 |
	self assert: ('abc' beginsWith: 'ab').
	self assert: ('abc' beginsWith: 'ab' asWideString).
	self assert: ('abc' asWideString beginsWith: 'ab').
	self assert: ('abc' beginsWith: 'aX') not .
	self assert: ('abc' beginsWith: 'AB') not.
	self assert: ('abc' beginsWith: 'AB' asWideString) not .
	self assert: ('ABC' asWideString beginsWith: 'ab') not.

	w1 := WideString with: (Unicode value: 402) with: $a with: (Unicode value: 400) with: $b.
	w2 := WideString with: (Unicode value: 402).
	w1 beginsWith: w2.
! !

!WideStringTest methodsFor: 'tests - match' stamp: 'nice 7/28/2007 23:22'!
testCharactersExactlyMatching
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"
	
	self assert: ('abc' charactersExactlyMatching: 'abc') = 3.
	self assert: ('abd' charactersExactlyMatching: 'abc') = 2.
	self assert: ('abc' charactersExactlyMatching: 'abc' asWideString) = 3.
	self assert: ('abd' charactersExactlyMatching: 'abc' asWideString) = 2.
	self assert: ('abc' asWideString charactersExactlyMatching: 'abc') = 3.
	self assert: ('abd' asWideString charactersExactlyMatching: 'abc') = 2.
	self assert: ('abc' asWideString charactersExactlyMatching: 'abc' asWideString) = 3.
	self assert: ('abd' asWideString charactersExactlyMatching: 'abc' asWideString)= 2.
	self assert: ('abc' charactersExactlyMatching: 'ABC') = 0.

! !

!WideStringTest methodsFor: 'tests - compare' stamp: 'nice 7/28/2007 23:19'!
testCompare
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"
	
	self assert: ('abc' compare: 'abc') = 2.
	self assert: ('abc' compare: 'abd') = 1.
	self assert: ('abd' compare: 'abc') = 3.
	self assert: ('abc' compare: 'abC') = 2.
	self assert: ('abc' compare: 'abD') = 1.
	self assert: ('abd' compare: 'abC') = 3.
	self assert: ('aBc' compare: 'abC') = 2.
	self assert: ('aBc' compare: 'abD') = 1.
	self assert: ('aDd' compare: 'abC') = 3.
	
	
	self assert: ('abc' compare: 'abc' asWideString) = 2.
	self assert: ('abc' compare: 'abd' asWideString) = 1.
	self assert: ('abd' compare: 'abc' asWideString) = 3.
	self assert: ('abc' compare: 'abC' asWideString) = 2.
	self assert: ('abc' compare: 'abD' asWideString) = 1.
	self assert: ('abd' compare: 'abC' asWideString) = 3.
	self assert: ('aBc' compare: 'abC' asWideString) = 2.
	self assert: ('aBc' compare: 'abD' asWideString) = 1.
	self assert: ('aDd' compare: 'abC' asWideString) = 3.
	
	self assert: ('abc' asWideString compare: 'abc') = 2.
	self assert: ('abc' asWideString compare: 'abd') = 1.
	self assert: ('abd' asWideString compare: 'abc') = 3.
	self assert: ('abc' asWideString compare: 'abC') = 2.
	self assert: ('abc' asWideString compare: 'abD') = 1.
	self assert: ('abd' asWideString compare: 'abC') = 3.
	self assert: ('aBc' asWideString compare: 'abC') = 2.
	self assert: ('aBc' asWideString compare: 'abD') = 1.
	self assert: ('aDd' asWideString compare: 'abC') = 3.
	
	self assert: ('abc' asWideString compare: 'abc' asWideString) = 2.
	self assert: ('abc' asWideString compare: 'abd' asWideString) = 1.
	self assert: ('abd' asWideString compare: 'abc' asWideString) = 3.
	self assert: ('abc' asWideString compare: 'abC' asWideString) = 2.
	self assert: ('abc' asWideString compare: 'abD' asWideString) = 1.
	self assert: ('abd' asWideString compare: 'abC' asWideString) = 3.
	self assert: ('aBc' asWideString compare: 'abC' asWideString) = 2.
	self assert: ('aBc' asWideString compare: 'abD' asWideString) = 1.
	self assert: ('aDd' asWideString compare: 'abC' asWideString) = 3.
	
	self assert: ('abc' compare: 'abc' caseSensitive: true) = 2.
	self assert: ('abc' compare: 'abC' caseSensitive: false) = 2.
	self assert: ('abc' compare: 'abc' asWideString caseSensitive: true) = 2.
	self assert: ('abc' compare: 'abC' asWideString caseSensitive: false) = 2.
	self assert: ('abc' asWideString compare: 'abc' caseSensitive: true) = 2.
	self assert: ('abc' asWideString compare: 'abC' caseSensitive: false) = 2.
	self assert: ('abc' asWideString compare: 'abc' asWideString caseSensitive: true) = 2.
	self assert: ('abc' asWideString compare: 'abC' asWideString caseSensitive: false) = 2.! !

!WideStringTest methodsFor: 'tests - endswith' stamp: 'nice 7/28/2007 23:30'!
testEndsWith
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"
	
	self assert: ('abc' endsWith: 'bc').
	self assert: ('abc' endsWith: 'bc' asWideString).
	self assert: ('abc' asWideString endsWith: 'bc').
	self assert: ('abc' endsWith: 'bX') not .
	self assert: ('abc' endsWith: 'BC') not.
	self assert: ('abc' endsWith: 'BC' asWideString) not .
	self assert: ('ABC' asWideString endsWith: 'bc') not.

! !

!WideStringTest methodsFor: 'tests - compare' stamp: 'StephaneDucasse 2/3/2010 22:22'!
testEqual
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"
	
	self assert: 'abc' = 'abc'.
	self assert: 'abc' = 'abc' asWideString.
	self assert: 'abc' asWideString = 'abc'.
	self assert: 'abc' asWideString = 'abc' asWideString.
	self assert: ('abc' = 'ABC') not.
	self assert: ('abc' = 'ABC' asWideString) not.
	self assert: ('abc' asWideString = 'ABC') not.
	self assert: ('abc' asWideString = 'abc' asWideString).
	self assert: ( #[97 0 0 0] asString ~= 'a000' asWideString).
	self assert: ('a000' asWideString ~=  #[97 0 0 0] asString).! !

!WideStringTest methodsFor: 'tests - substrings' stamp: 'nice 7/28/2007 00:46'!
testFindSubstring
	"This is related to http://bugs.squeak.org/view.php?id=6366
	finding substring in a WideString was broken because matchTable are byte-wise"
	
	| ws1 ws2 |
	
	self assert: ('abcd' findString: 'bc' startingAt: 1) = 2.
	self assert: ('abcd' asWideString findString: 'bc' startingAt: 1) = 2.
	self assert: ('abcd' findString: 'bc' asWideString startingAt: 1) = 2.
	self assert: ('abcd' asWideString findString: 'bc' asWideString startingAt: 1) = 2.
	
	ws1 := 'A' , (WideString with: (Unicode value: 530)) , 'BCD'.
	self assert: (ws1 findString: 'bc' startingAt: 1 caseSensitive: true) = 0.
	self assert: (ws1 findString: 'bc' startingAt: 1 caseSensitive: false) = 3.
	
	ws2 := (WideString with: (Unicode value: 530)) , 'b'.
	self assert: (ws1 findString: ws2 startingAt: 1 caseSensitive: true) = 0.
	self assert: (ws1 findString: ws2 startingAt: 1 caseSensitive: false) = 2.
	
	self assert: ('abc' findString: ws2 startingAt: 1 caseSensitive: true) = 0.
	self assert: ('abc' findString: ws2 startingAt: 1 caseSensitive: false) = 0.! !

!WideStringTest methodsFor: 'tests - match' stamp: 'nice 7/28/2007 23:16'!
testMatch
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"
	
	self assert: ('*baz' match: 'mobaz' ).
	self assert: ('*foo#zort' match: 'afoo3zortthenfoo3zort' ).
	self assert: ('*baz' match: 'mobaz' ).
	self assert: ('*foo#zort' match: 'afoo3zortthenfoo3zort' ).
	
	self assert: ('*baz' match: 'mobaz' asWideString).
	self assert: ('*foo#zort' match: 'afoo3zortthenfoo3zort' asWideString).
	self assert: ('*baz' match: 'mobaz' asWideString).
	self assert: ('*foo#zort' match: 'afoo3zortthenfoo3zort' asWideString).
	
	self assert: ('*baz' asWideString match: 'mobaz' ).
	self assert: ('*foo#zort' asWideString match: 'afoo3zortthenfoo3zort' ).
	self assert: ('*baz' asWideString match: 'mobaz' ).
	self assert: ('*foo#zort' asWideString match: 'afoo3zortthenfoo3zort' ).
	
	self assert: ('*baz' asWideString match: 'mobaz' asWideString).
	self assert: ('*foo#zort' asWideString match: 'afoo3zortthenfoo3zort' asWideString).
	self assert: ('*baz' asWideString match: 'mobaz' asWideString).
	self assert: ('*foo#zort' asWideString match: 'afoo3zortthenfoo3zort' asWideString).! !

!WideStringTest methodsFor: 'tests - relation order' stamp: 'nice 7/28/2007 23:14'!
testRelationOrder
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"

	self assert: ('aa' < 'ab').
	self assert: ('aa' <= 'ab').
	self assert: ('aa' <= 'aa').
	self assert: ('ab' > 'aa').
	self assert: ('ab' >= 'aa').
	self assert: ('aa' >= 'aa').
	
	self assert: ('aa' < 'ab' asWideString).
	self assert: ('aa' <= 'ab' asWideString).
	self assert: ('aa' <= 'aa' asWideString).
	self assert: ('ab' > 'aa' asWideString).
	self assert: ('ab' >= 'aa' asWideString).
	self assert: ('aa' >= 'aa' asWideString).
	
	self assert: ('aa' asWideString < 'ab').
	self assert: ('aa' asWideString <= 'ab').
	self assert: ('aa' asWideString <= 'aa').
	self assert: ('ab' asWideString > 'aa').
	self assert: ('ab' asWideString >= 'aa').
	self assert: ('aa' asWideString >= 'aa').
	
	self assert: ('aa' asWideString< 'ab' asWideString).
	self assert: ('aa' asWideString<= 'ab' asWideString).
	self assert: ('aa' asWideString<= 'aa' asWideString).
	self assert: ('ab' asWideString> 'aa' asWideString).
	self assert: ('ab' asWideString >= 'aa' asWideString).
	self assert: ('aa' asWideString>= 'aa' asWideString).! !

!WideStringTest methodsFor: 'tests - relation order' stamp: 'nice 7/28/2007 23:21'!
testRelationOrderWithCase
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"
		
	self assert: ('ABC' caseInsensitiveLessOrEqual: 'abc').
	self assert: ('ABC' caseInsensitiveLessOrEqual: 'abd').
	self assert: ('ABD' caseInsensitiveLessOrEqual: 'abc') not.
	self assert: ('ABC' caseInsensitiveLessOrEqual: 'abc' asWideString).
	self assert: ('ABC' caseInsensitiveLessOrEqual: 'abd' asWideString).
	self assert: ('ABD' caseInsensitiveLessOrEqual: 'abc' asWideString) not.
	self assert: ('ABC' asWideString caseInsensitiveLessOrEqual: 'abc').
	self assert: ('ABC' asWideString caseInsensitiveLessOrEqual: 'abd').
	self assert: ('ABD' asWideString caseInsensitiveLessOrEqual: 'abc') not.
	self assert: ('ABC' asWideString caseInsensitiveLessOrEqual: 'abc' asWideString).
	self assert: ('ABC' asWideString caseInsensitiveLessOrEqual: 'abd' asWideString).
	self assert: ('ABD' asWideString caseInsensitiveLessOrEqual: 'abc' asWideString) not.
	
	
	self assert: ('abc' caseSensitiveLessOrEqual: 'abc').
	self assert: ('abc' caseSensitiveLessOrEqual: 'abd').
	self assert: ('abd' caseSensitiveLessOrEqual: 'abc') not.
	self assert: ('abc' caseSensitiveLessOrEqual: 'abc' asWideString).
	self assert: ('abc' caseSensitiveLessOrEqual: 'abd' asWideString).
	self assert: ('abd' caseSensitiveLessOrEqual: 'abc' asWideString) not.
	self assert: ('abc' asWideString caseSensitiveLessOrEqual: 'abc').
	self assert: ('abc' asWideString caseSensitiveLessOrEqual: 'abd').
	self assert: ('abd' asWideString caseSensitiveLessOrEqual: 'abc') not.
	self assert: ('abc' caseSensitiveLessOrEqual: 'ABC') not.
	! !

!WideStringTest methodsFor: 'tests - compare' stamp: 'StephaneDucasse 2/3/2010 22:22'!
testSameAs
	"from johnmci at http://bugs.squeak.org/view.php?id=5331"

	self assert: ('abc' sameAs: 'aBc' asWideString).
	self assert: ('aBc' asWideString sameAs: 'abc').
	self assert: ( #[97 0 0 0] asString sameAs: 'Abcd' asWideString) not.
	self assert: ('a000' asWideString sameAs:  #[97 0 0 0] asString) not.
	! !

!WideStringTest methodsFor: 'tests - substrings' stamp: 'nice 3/23/2007 01:52'!
testSubstrings
	"this is related to http://bugs.squeak.org/view.php?id=6367"
	
	| w1 w2 |
	w1 := WideString with: 401 asCharacter with: $a with: 402 asCharacter with: $b.
	w2 := WideString with: 403 asCharacter with: 404 asCharacter.

	self assert: w1 substrings first = w1.
	self assert: (w1 , ' ' , w2) substrings size = 2.
	self assert: (w1 , ' ' , w2) substrings last = w2.! !
